/*-------------------------------------------------------------------
   code07d0.c - code resource #2000, the main config form
-------------------------------------------------------------------*/

#include <PalmOS.h>

#include "KioskHack.h"
#include "resource.h"

/* Copyright (c) 2005 Raymond Ingles.

   This is free software; you can redistribute it and/or modify it under the
   terms of the GNU General Public License as published by the Free Software
   Foundation; either version 2, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.  */

Boolean Pass_Unset_P(UInt32 *hash);

/*##################################################################
  Jump to our start function.
##################################################################*/

asm ( " bra MainForm" );

/*##################################################################*/
Boolean MainForm	( EventPtr event )
/*##################################################################*/
{
  Boolean handled = false;
  Kiosk_Prefs prefs;
  UInt16 prefs_size;

  switch ( event->eType ) {
  case frmOpenEvent:
    {
      FormType *form = FrmGetActiveForm();

      /* Retrieve or create our preferences. */
      prefs_size = sizeof(prefs);
      if (noPreferenceFound == 
          PrefGetAppPreferences(HACK_ID, 0, &prefs, &prefs_size, true)) {
        MemSet(&prefs, sizeof(prefs), 0);
      } else {
        /* Configuring the hack always unlocks things. */
        prefs.locked_p = 0;
      }
      PrefSetAppPreferences(HACK_ID, 0, 1, &prefs, sizeof(prefs), true);

      /* Set up form values from prefs. */
      FrmSetControlValue(form, FrmGetObjectIndex(form, KIOSK_BLOCKSECR_CB_ID),
                         prefs.blocksecr_p);
      FrmSetControlValue(form, FrmGetObjectIndex(form, KIOSK_BLOCKPANL_CB_ID),
                         prefs.blockpanl_p);
      FrmSetControlValue(form, FrmGetObjectIndex(form, KIOSK_BEEPLOCK_CB_ID),
                         prefs.beeplock_p);
      FrmSetControlValue(form, FrmGetObjectIndex(form, KIOSK_BEEPLAUNCH_CB_ID),
                         prefs.beeplaunch_p);

      if (Pass_Unset_P((UInt32 *)prefs.passwd_hash)) {
        CtlSetLabel(FrmGetObjectPtr(form,
                                    FrmGetObjectIndex(form,
                                                      KIOSK_PWSEL_TR_ID)),
                    "Unassigned");
      } else {
        CtlSetLabel(FrmGetObjectPtr(form,
                                    FrmGetObjectIndex(form,
                                                      KIOSK_PWSEL_TR_ID)),
                    "Assigned");
      }
      FrmDrawForm(form);
    }
    break;

  case frmCloseEvent:
    break;

  case ctlSelectEvent:
    switch( event->data.ctlEnter.controlID ) {
    case KIOSK_OK_B_ID:
      if (Pass_Unset_P((UInt32 *)prefs.passwd_hash)) {
          FrmAlert(KIOSK_PWERR_AL_ID);
      } else {
        FormType *form = FrmGetActiveForm();

        /* Set the prefs from the values in the form. */
        prefs_size = sizeof(prefs);
        PrefGetAppPreferences(HACK_ID, 0, &prefs, &prefs_size, true);
        prefs.blockpanl_p = (FrmGetControlValue(form, FrmGetObjectIndex(form,
                                                   KIOSK_BLOCKPANL_CB_ID)));
        prefs.blocksecr_p = (FrmGetControlValue(form, FrmGetObjectIndex(form,
                                                   KIOSK_BLOCKSECR_CB_ID)));
        prefs.beeplock_p = (FrmGetControlValue(form, FrmGetObjectIndex(form,
                                                   KIOSK_BEEPLOCK_CB_ID)));
        prefs.beeplaunch_p = (FrmGetControlValue(form, FrmGetObjectIndex(form,
                                                   KIOSK_BEEPLAUNCH_CB_ID)));
        PrefSetAppPreferences(HACK_ID, 0, 1, &prefs, sizeof(prefs), true);
      }
      /* falls through! */
    case KIOSK_CANCEL_B_ID:
      FrmGotoForm( 9000 );
      handled = true;
      break;

    case KIOSK_PWSEL_TR_ID:
      FrmGotoForm(KIOSK_SETPW_F);
      handled = true;
      break;

    case KIOSK_BLOCKPANL_CB_ID:
    case KIOSK_BLOCKSECR_CB_ID:
    case KIOSK_BEEPLOCK_CB_ID:
    case KIOSK_BEEPLAUNCH_CB_ID:
      handled = true;
      break;
    }
    break;

  default:
    break;
  }

return handled;
}

Boolean Pass_Unset_P(UInt32 *hash) {
  int i;

  for (i=0; i<4; i++) {
    if (hash[i]) {
      return false;
    }
  }
  /* all bits zero, unset. */
  return true;
}
