/*-------------------------------------------------------------------
   code07d1.c - code resource #2001, the 'set password' form
-------------------------------------------------------------------*/

#include <PalmOS.h>

#include "KioskHack.h"
#include "resource.h"

/* Copyright (c) 2005 Raymond Ingles.

   This is free software; you can redistribute it and/or modify it under the
   terms of the GNU General Public License as published by the Free Software
   Foundation; either version 2, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.  */

/*##################################################################
  Jump to our start function.
##################################################################*/

asm ( " bra MainForm" );

/*##################################################################*/
Boolean MainForm	( EventPtr event )
/*##################################################################*/
{
  Boolean handled = false;
  Kiosk_Prefs prefs;
  UInt16 prefs_size;

  switch ( event->eType ) {
  case frmOpenEvent:
    {
      FormType *form = FrmGetActiveForm();
      /* Set up form values. */

      prefs_size = sizeof(prefs);
      if (noPreferenceFound == PrefGetAppPreferences(HACK_ID, 0, &prefs,
                                                     &prefs_size, true)) {
        /* This should never happen, right? */
      }
      FrmSetControlValue(form, FrmGetObjectIndex(form, KIOSK_VEIL_CB_ID),
                         prefs.hidepw_p);
      /* Text is still there, just displayed as squares. */
      FldSetFont(FrmGetObjectPtr(form,
                                 FrmGetObjectIndex(form, KIOSK_PASS_FL_ID)),
                 prefs.hidepw_p ? symbol11Font : stdFont);
      FrmDrawForm(form);
    }
    break;

  case frmCloseEvent:
    break;

  case ctlSelectEvent:
    switch( event->data.ctlEnter.controlID ) {
    case KIOSK_OK_B_ID:
      {
        FormType *form = FrmGetActiveForm();
        char *pwd_txt;

        pwd_txt = FldGetTextPtr(FrmGetObjectPtr(form, FrmGetObjectIndex(form,
                                                        KIOSK_PASS_FL_ID)));
        if (pwd_txt && StrLen(pwd_txt)) {
          prefs_size = sizeof(prefs);
          PrefGetAppPreferences(HACK_ID, 0, &prefs, &prefs_size, true);

          /* Compute the MD5 hash of the password. */
          EncDigestMD5(pwd_txt, StrLen(pwd_txt), prefs.passwd_hash);
          /* Are we hiding or not? */
          prefs.hidepw_p = (FrmGetControlValue(form, FrmGetObjectIndex(form,
                                                   KIOSK_VEIL_CB_ID)));
          /* Store 'em. */
          PrefSetAppPreferences(HACK_ID, 0, 1, &prefs, sizeof(prefs), true);
        } else {
          FrmAlert(KIOSK_PWERR_AL_ID);
          handled = true;
          break;
        }
      }
      /* falls through! */
    case KIOSK_CANCEL_B_ID:
      FrmGotoForm(KIOSK_MAIN_F);
      handled = true;
      break;

    case KIOSK_VEIL_CB_ID:
      {
        FormType *form = FrmGetActiveForm();
        /* Text is still there, just displayed as squares. */
        FldSetFont(FrmGetObjectPtr(form,
                                   FrmGetObjectIndex(form, KIOSK_PASS_FL_ID)),
                   (FrmGetControlValue(form, FrmGetObjectIndex(form,
                                KIOSK_VEIL_CB_ID))) ? symbol11Font : stdFont);
        handled = true;
      }
      break;
    }
    break;

  default:
    break;
  }

return handled;
}
